<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Province</h2>
    <p>Select province</p>

    <form id="inputform01" class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country">Province</label>
        </div>
        <div class="col-sm-3">
          <select id="province-select" name="country" class="form-control">
            <option value="all">Please Choose!</option>
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region">District</label>
        </div>
        <div class="col-sm-3">
          <select id="district-select" disabled name="region" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region">Ward</label>
        </div>
        <div class="col-sm-3">
          <select id="ward-select" disabled name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row pull-right">
        <div class="col-sm-12">
          <input type="button" value="Send" class="btn btn-info" id="send-button">
        </div>
      </div>
    </form>
  </div>
  <script>
    //Get data provinces
    $.ajax({
      url: "http://localhost:8080/provinces",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToProvinceSelect(pObjRes);
      },
      error: function(pXhrObj) {
        console.log(pXhrObj);
      }
    });

    var gProvinceSelectElement = $("#province-select");

    function loadDataToProvinceSelect(pProvinceList) {
      for (i = 0; i < pProvinceList.length; i++) {
        var bProvinceOption = $("<option/>");
        bProvinceOption.prop("value", pProvinceList[i].id);
        bProvinceOption.prop("text", pProvinceList[i].name);
        gProvinceSelectElement.append(bProvinceOption);
      };
    }

    var gDistrictSelectElement = $("#district-select");
    var gWardSelectElement = $("#ward-select");

    //callback function
    gProvinceSelectElement.on("change", function () {
      gDistrictSelectElement.html("");
      var bProvinceCode = $(this).val();

      console.log("Province code is selected: "+ bProvinceCode);
      getDistrictByProvinceCode(bProvinceCode);
    });

    //find district by Province id
    function getDistrictByProvinceCode(bProvinceCode) {
      $.ajax({
        url: "http://localhost:8080/district_by_province?provinceId="+ bProvinceCode,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToDistrictSelect(pObjRes);
        },
        error: function(pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToDistrictSelect(pDistrictList) {
      if (pDistrictList.length > 0) {
        gDistrictSelectElement.prop("disabled", false);

        for (i = 0; i < pDistrictList.length; i++) {
          var bDistrictOption = $("<option/>");
          bDistrictOption.prop("value", pDistrictList[i].id);
          bDistrictOption.prop("text", pDistrictList[i].name);
          gDistrictSelectElement.append(bDistrictOption);
        };
      } else {
        gDistrictSelectElement.prop("disabled", "disabled");
      }
    }

  </script>
</body>

</html>